package edu.ucf.cs.courses.cop4610l.beans.crypto;

/**
 * @author Mathew B. Lowery
 * @version 1.0
 */

import java.awt.*;
import java.beans.*;
import java.io.*;

/**
 * @see Crypto
 */
public class CryptoBeanInfo extends SimpleBeanInfo {
  public static final Class beanClass = Crypto.class;

  /**
   * Provides a nice description for tool tips.
   */
  public BeanDescriptor getBeanDescriptor() {
    BeanDescriptor descriptor = new BeanDescriptor(beanClass);
    descriptor.setDisplayName("Crypto");
    descriptor.setShortDescription("A bean for common crypto functions.");
    return descriptor;
  }

  /**
   * This class is used to restrict the methods that the builder tool displays.
   * Otherwise, all inherited methods would be displayed.
   */
  public MethodDescriptor[] getMethodDescriptors() {
    try {
      MethodDescriptor getSymmetricTransformedStream =
            new MethodDescriptor(beanClass.getMethod(
                  "getSymmetricTransformedStream", null));

      Class[] params = new Class[1];
      params[0] = InputStream.class;
      MethodDescriptor doSymmetricEncrypt =
            new MethodDescriptor(beanClass.getMethod(
                  "doSymmetricEncrypt", params));
     MethodDescriptor doSymmetricDecrypt =
            new MethodDescriptor(beanClass.getMethod(
                  "doSymmetricDecrypt", params));
      MethodDescriptor[] descriptors = {getSymmetricTransformedStream,
                                        doSymmetricEncrypt,
                                        doSymmetricDecrypt};
      return descriptors;
    }
    catch (NoSuchMethodException e) {
      e.printStackTrace();
    }
    return null;
  }

  /**
   * Custom icons for builder tools.
   */
  public Image getIcon(int iconKind) {
    Image image = null;
    String imageDir = "/edu/ucf/cs/courses/cop4610l/beans/images";
    switch (iconKind) {
      case ICON_COLOR_16x16:
        image = loadImage(imageDir + "/pegasus16x16.gif");
        break;
      case ICON_COLOR_32x32:
        image = loadImage(imageDir + "/pegasus32x32.gif");
        break;
      case ICON_MONO_16x16:
        image = loadImage(imageDir + "/pegasus16x16m.gif");
        break;
      case ICON_MONO_32x32:
        image = loadImage(imageDir + "/pegasus32x32m.gif");
        break;
      default:
        break;
    } // switch
    return image;
  } // getIcon
} // CryptoBeanInfo