package edu.ucf.cs.courses.cop4610l.beans.crypto;

/**
 * @author Mathew B. Lowery
 * @version 1.0
 */

import java.util.*;

/**
 * Interface that listeners must implement to hear transformation
 * (i.e. encrypt, decrypt, etc) completion events.
 * @see Crypto
 */
public interface TransformCompletedListener extends EventListener {

  /**
   * When this method is called on listeners, the transformed stream is ready
   * to be consumed.
   * @param e the event encapsulating the stream
   */
  public void transformCompleted(TransformCompletedEvent e);

} // TransformCompletedEvent