package edu.ucf.cs.courses.cop4610l.beans.test;

/**
 * @author Mathew B. Lowery
 * @version 1.0
 */

import edu.ucf.cs.courses.cop4610l.beans.crypto.*;
import edu.ucf.cs.courses.cop4610l.beans.streams.*;

public class ClearToCipherTest {
  StringToStream toStream = new StringToStream();
  Crypto crypto = new Crypto();
  StreamToString toString = new StreamToString();
  String cleartext = "Hello there my name is Mat.";
  String ciphertext;

  public ClearToCipherTest() throws Exception {


    crypto.addTransformCompletedListener(new TransformCompletedListener() {
      public void transformCompleted(TransformCompletedEvent e) {
        System.out.println("EVENT: transform completed");
        crypto_transformCompleted(e);
      }
    });
    toStream.addStreamConstructedListener(new StreamConstructedListener() {
      public void streamConstructed(StreamConstructedEvent e) {
        System.out.println("EVENT: stream constructed");
        toStream_streamConstructed(e);
      }
    });
    toString.addStringConstructedListener(new StringConstructedListener() {
      public void stringConstructed(StringConstructedEvent e) {
        System.out.println("EVENT: string constructed");
        toString_stringConstructed(e);
      }
    });
    toStream.constructStream(cleartext);
    System.out.println("Cleartext: " + cleartext);
    System.out.println("Ciphertext: " + ciphertext);
  }
  public static void main(String[] args) throws Exception {
    new ClearToCipherTest();
  }

  public void toStream_streamConstructed(StreamConstructedEvent e) {
    System.out.println("stream (from string) is " + e.getStream());
    crypto.doSymmetricEncrypt(e.getStream());
  }

  public void crypto_transformCompleted(TransformCompletedEvent e) {
    System.out.println("stream (from crypto) is " + e.getStream());
    toString.constructString(e.getStream());
  }

  public void toString_stringConstructed(StringConstructedEvent e) {
    System.out.println("string (from stream) is " + e.getString());
    ciphertext = e.getString();
  }
}