package edu.ucf.cs.courses.cop4610l.beans.test;

/**
 * @author Mathew B. Lowery
 * @version 1.0
 */

import java.security.*;
import java.io.*;
import javax.crypto.*;

public class KeyStoreTest {

  public KeyStoreTest() {
  }

  public static KeyStore loadKeyStore(String filename, String password)
                                                        throws Exception {
    FileInputStream fin = new FileInputStream(filename);
    BufferedInputStream bin = new BufferedInputStream(fin);
    KeyStore keyStore = KeyStore.getInstance(KeyStore.getDefaultType());
    keyStore.load(bin, password.toCharArray());
    bin.close();
    fin.close();
    return keyStore;
  }

  public static KeyStore createKeyStore() throws Exception {
    KeyStore keyStore = KeyStore.getInstance(KeyStore.getDefaultType());
    keyStore.load(null, null);
    return keyStore;
  }

  public static void storeKeyStore(KeyStore keyStore, String filename,
                                       String password) throws Exception {
    FileOutputStream fout = new FileOutputStream(filename);
    BufferedOutputStream bout = new BufferedOutputStream(fout);
    keyStore.store(bout, password.toCharArray());
    bout.close();
    fout.close();
  }

  public static void setKey(Key key, String alias, String password,
                                     KeyStore keyStore) throws Exception {
    keyStore.setKeyEntry(alias, key, password.toCharArray(), null);
  }

  public static Key generateKey(String cipherName) throws Exception {
      KeyGenerator keyGenerator = KeyGenerator.getInstance(cipherName);
      return keyGenerator.generateKey();
  }

  public static void main(String[] args) throws Exception {
    KeyStore testKeyStore = KeyStoreTest.createKeyStore();
    Key testKey = KeyStoreTest.generateKey("DES");
    KeyStoreTest.setKey(testKey, "hello", "hello", testKeyStore);
    KeyStoreTest.storeKeyStore(testKeyStore, "c:/temp2/testkeystore", "hello");
  }
}